import org.mozilla.xpcom.*;

public class nsJavaFoo implements nsIFoo {
    public Object queryInterface(IID iid) {
		System.out.println("nsJavaFoo.queryInterface called");
        Object result;
        if ( iid.equals(nsISupports.IID)
             || iid.equals(nsIFoo.IID)) {
            result = this;
        } else {
            result = null;
        }
        return result;
    }

    public void foo1(int l) {
        System.out.println("Foo on you: " + l);
    }

    public void foo2() {
	  nsIXPIDLServiceManager sm = Components.getServiceManager();
	  IID consoleServiceIID = new IID("a647f184-1dd1-11b2-a9d1-8537b201161b");
	  nsIConsoleService console = 
		(nsIConsoleService)sm.getServiceByContractID("@mozilla.org/consoleservice;1", consoleServiceIID)
										.queryInterface(consoleServiceIID);
	  // this won't print if from xpcshell, only in the JavaScript console if a debug build of Mozilla is running
	  // bkn3@columbia.edu
	  console.logStringMessage("Hello cruel console world!");
    }

	// staticly load any XPCOM classes we use in the implementation
	// of our component
    static {
      try {
		Class nsIConsoleServiceClass = 
              Class.forName("org.mozilla.xpcom.nsIConsoleService");
		InterfaceRegistry.register(nsIConsoleServiceClass);

		Class nsIConsoleMessageClass = 
              Class.forName("org.mozilla.xpcom.nsIConsoleMessage");
		InterfaceRegistry.register(nsIConsoleMessageClass);

		Class nsIConsoleListenerClass = 
              Class.forName("org.mozilla.xpcom.nsIConsoleListener");
		InterfaceRegistry.register(nsIConsoleListenerClass);
      } catch (Exception e) {
          System.out.println(e);
      }
    }

}